CrossCorr <-
function (startX, endX, Avg=1, lum=4, sizePts=2, binPts=15,modulo=1440, Rverbose=0, myData1,myData2,fileName,Span, Increment,export=F,fileoutXcorr="") {
  #  starting column, ending column, Average or Individual, #minutes between points, # points to bin, # minutes/unit (usually day)
  # require delftfews, chron, zoo?
  #require(delftfews)
  #modulo = 1440
  startData1 <-1
  startData2 <-1
  
  CatBins1<-CatBin(startX, endX, Avg, lum, sizePts, binPts,modulo, 1, myData1)
  CatBins2<-CatBin(startX, endX, Avg, lum, sizePts, binPts,modulo, 1, myData2)
  # returns newMinPerBin,dataPts,binsPerDay,dayPts,dayCnt,animals, endData, DataList,plotCnt
  
  DataList1<-CatBins1$DataList
  DataList2<-CatBins2$DataList
  startDark <-as.character(format(as.POSIXct(myData1[startData1,1], origin="1970-01-01",tz="GMT"),"%H:%M:%S"))    #  get index of first darkness value
  op<-par()
  thisTime <- format(Sys.time(), "%b %d, %Y - %H:%M:%S");

  nameVector <- paste(" ",names(myData1[,startX:endX]),sep=" ")
  endXrel<-endX-startX+1
  nameVector2 <- paste(" ",names(myData2[,startX:endX]),sep=" ")
  endXrel<-endX-startX+1
  
  for (cnt in 1:CatBins1$plotCnt) {      #  1 plot per animal, for all animals 
    par(mfrow=c(2,1), mar = c(4, 4, 4, 0),oma=c(2,0,1,1)) 
    curX<-cnt+startX-1
    MaxLag <- (CatBins1$dataPts/binPts)*.33
    getCCF <- ccf(DataList1[cnt,],DataList2[cnt,],main="",lag.max = MaxLag,xlab = "",ylab="Correlation coefficient (r)")
    # Default is 10*log10(N/m) where N is the number of observations and m the number of series. 
    # Will be automatically limited to one less than the number of observations in the series.

    maxCheck <- CatBins1$dayPts/2
    periodPt <- which.max(getCCF$acf[]) 
    
    hrsPerPeriod <- (periodPt/CatBins1$binsPerDay)*(modulo/60)
    if (Avg)  {    
      title(paste('CrossCorrelation\nFile 1 & 2, Avg of',CatBins1$animals,'Columns: ',nameVector[1],' - ',nameVector[endXrel],";",nameVector2[1],' - ',nameVector2[endXrel],'\n (File 2)',myData2[startData2,1],'--',myData2[CatBins2$endData,1],'\nvs (File1)',myData1[startData1,1],'--',myData1[CatBins1$endData,1]),cex.main=.9)
      fileoutXcorrX <- sub(pattern=".", replacement="-Avg.", x=fileoutXcorr, fixed = TRUE)   # name of file for exported data
      fileoutXcorrP <- sub(pattern=".", replacement="-AvgPgram2.", x=fileoutXcorr, fixed = TRUE)   # name of file for exported data
      #fileoutXcorrX <- sub(pattern=".", replacement="-Avg.", x=fileoutXcorr, fixed = TRUE)
    } else {
      title(paste('CrossCorrelation\nFile 1 & 2, Column',curX,': ',nameVector[cnt],";",nameVector2[cnt],'\n(File 2)',myData2[startData2,1],'--',myData2[CatBins2$endData,1],'\nvs (File 1)',myData1[startData1,1],'--',myData1[CatBins1$endData,1]),cex.main=.9)
      fileoutXcorrX <- sub(pattern=".", replacement=paste("-col",cnt,".",sep=""), x=fileoutXcorr,fixed = TRUE)
      fileoutXcorrP <- sub(pattern=".", replacement=paste("-col",cnt,"-Pgram2.",sep=""), x=fileoutXcorr,fixed = TRUE)
      #fileoutXcorrX <- sub(pattern=".", replacement=paste("-col",cnt,".",sep=""), x=fileoutXcorr,fixed = TRUE)
    }  # add file name, add info on 2nd data set?
    title(sub = paste("Lag (#",CatBins1$newMinPerBin,"-min Bins)",sep=""),line=2)
    if (Rverbose!=-1){
      mtext(paste("Max Lag = ",MaxLag,'; Phase offset:',getCCF$lag[periodPt],' bins, ',getCCF$lag[periodPt]*CatBins1$newMinPerBin/60,' hr'),cex=.7,side=1,line=2.9)
    }
    # Use the periodogram -- second data file data set only;  write result to file fileoutXcorrP
    CatPeriodogram<- CatPeri(DataList2[cnt,],binsPerHr=CatBins2$binsPerDay/(modulo/60), minsPerBin=CatBins2$newMinPerBin, export=export, fileoutP=fileoutXcorrP,Hx=.2, cex=.75, Rverbose=Rverbose)    # get Units working
    View(DataList2[cnt,])
    #DataList[cnt,]
    title('\n\nPeriodogram of File 2 data',cex.main=.9)
    n<-length(DataList2[cnt,])
    nfft<-(n/2)+1
    
    #------------------------
    
    #mtext(paste("Max Lag= ",MaxLag,";    1st Peak:",periodPt,'bins (', hrsPerPeriod,"hrs)"),cex=.8,side=1,line=2.9)
    if (Rverbose!=-1){
      mtext(paste('File 2: Total bins: ',CatBins2$dataPts/binPts,';     pts/bin: ',binPts,'(',CatBins2$newMinPerBin,'mins)'),side=1,line = 2.9, cex =.7)    #     bins/day: ',CatBins$binsPerDay
    }

    #mtext(thisTime,side=1,line = 5, cex =.8, adj=.8)
    mtext(paste("Span:",Span," Inc:",Increment),side=1,line = 3.75, cex =.5, adj=.1)
    mtext(paste(fileName,"   ",thisTime),side=1,line = 3.75, cex =.5, adj=.9)
    if (export==T){
      #print(fileoutXcorrX)
      write.matrix(cbind(getCCF$lag,getCCF$acf), file = fileoutXcorrX, sep = "\t")   #  file 2 is the experimental data
      #print(file1outXcorrX)
      #write.matrix(cbind(getCCF$lag,getCCF$acf), file = file1outXcorrX, sep = ",")
    }
  }  # end for (cnt in 1:CatBins1$plotCnt)
  #remove read only list components 
  op$cin<-NULL
  op$cra<-NULL
  op$csi<-NULL
  op$cxy<-NULL
  op$din<-NULL
  op$page<-NULL
  par(op)
  end
}
